/*********************************************************************************
	f[^x[X API
*********************************************************************************/

#ifndef API_ADB_H
#define API_ADB_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_ADB
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* CuID擾 */
/*
	f[^x[XǗCuɊւdlł́A
	f[^̂߂̃C^[tFCXƂ݂̓̂K肵A
	t@CtH[}bg\̓Cu҂Ɉς˂܂B

	̑_́AC^[tFCXƎSɐ؂藣A
	xł̎dlύXA@\gRɍs悤ɂ邱ƂƁA
	Cu̗p҂A̍قӎ邱ƂȂA
	ꂳꂽC^[tFCXDB̑삪s悤ɂ邱Ƃɂ܂B

	Cu̎҂ adbCreate ֐ɂăf[^x[X̍쐬sƂɁA
	w肳ꂽfBNg̒ libid Ƃt@C쐬A
	{֐Ŏ擾ł̂Ɠj[NIDݒ肷悤ɂȂ΂Ȃ܂B
	ꂪf[^x[XɂĖmɋK肳B̃t@CdlƂȂ܂B

	libid t@C(16byte)

	AhX|	GUID\̃o|	f[^
	-----------------------------------------------
	0000H	|	data1			|	4byte(gGfBA)
	0004H	|	data2			|	2byte(gGfBA)
	0006H	|	data3			|	2byte(gGfBA)
	0008H	|	data4[0]		|	1byte
	0009H	|	data4[1]		|	1byte
	000AH	|	data4[2]		|	1byte
	000BH	|	data4[3]		|	1byte
	000CH	|	data4[4]		|	1byte
	000DH	|	data4[5]		|	1byte
	000EH	|	data4[6]		|	1byte
	000FH	|	data4[7]		|	1byte
*/
ADBM_PREFIX void ADBM_API adbGetLibraryID( ADBM_PGUID pLibID ) ;

/* Cũo[W擾 */
ADBM_PREFIX ADBM_DWORD ADBM_API adbGetLibraryVersion( void ) ;

/* f[^x[X쐬 */
/*
	pszADBDirPath ɂ́Af[^x[XɊւt@Ci[ׂ̃fBNĝw肵܂B
	w肳ꂽfBNgɑ݂ꍇA{֐͎s܂B

	maxPath ɂ̓pXobt@̏(ʏ_MAX_PATH+1)w肵܂B

	maxFileAttNum ɂ̓t@Cɐݒł鑮̏w肵܂B

	maxCommentLength ɂ̓t@C̃Rgobt@̏w肵܂B
	maxCommentLength 0w肵ꍇARgf[^x[X͍쐬܂B

	attExDataSize ɂ͑̕ti[obt@TCY(Œl)w肵܂B
	t̃tH[}bgDB̍쐬҂RɌ߂邱Ƃł܂B

	fileExDataSize ɂ̓t@C̕ti[obt@TCY(Œl)w肵܂B
	t̃tH[}bgDB̍쐬҂RɌ߂邱Ƃł܂B

	hashSize ɂ̓t@CnbṼTCY(Œl)w肵܂B
	hashSize 0w肵ꍇAnbVf[^x[X͍쐬܂B
	̏ꍇAdǗƃC|[g@\͎g܂B

	maxAttNameLength ɂ͑̕obt@̏w肵܂B

	pPathCompFNCID ɂ̓pX̔r֐ID̃|C^w肵܂B
	ʏ̓Cu񋟂r֐ID|C^w肵܂B
	r֐JX^}CYꍇ̓[U[`ID|C^w肵܂B

	pDBInfo ɂ͕Kvɉăf[^x[Xw肵Ċi[ł܂B
	f[^x[X̃tH[}bgDB̍쐬҂RɌ߂邱Ƃł܂B

	obt@̏ݒɂ́AI[0܂߂TCYw肵ĂB
*/
ADBM_PREFIX ADBM_ERROR ADBM_API adbCreate(
	ADBM_CSTR pszADBDirPath,
	ADBM_UINT32 maxPath,
	ADBM_UINT32 maxFileAttNum,
	ADBM_UINT32 maxCommentLength,
	ADBM_UINT32 attExDataSize,
	ADBM_UINT32 fileExDataSize,
	ADBM_UINT32 hashSize,
	ADBM_UINT32 maxAttNameLength,
	ADBM_PCGUID pPathCompFNCID,
	const void * pDBInfo, ADBM_UINT32 dbInfoSize ) ;

/* f[^x[XƃCuƂ̌݊𒲂ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbIsSupported( ADBM_CSTR pszADBDirPath ) ;

/* f[^x[XꂽCũo[W擾 */
ADBM_PREFIX ADBM_DWORD ADBM_API adbGetDBVersion( ADBM_CSTR pszADBDirPath ) ;

/* f[^x[X̃TCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetDBInfoSize( ADBM_CSTR pszADBDirPath ) ;

/* f[^x[X擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API adbGetDBInfo( ADBM_CSTR pszADBDirPath, void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* ΏۂƂ鑮f[^x[X֘At */
/*
	pPathCompFNCID ɃCu񋟂r֐ID̃|C^w肵ꍇA
	pathCompare ɂ NULL w肵Ȃ΂Ȃ܂B
	[U[`̔r֐pꍇApPathCompFNCID  pathCompare K؂Ɏw肵ĂB
	pPathCompFNCID Af[^x[X̍쐬Ɏw肳ꂽ̂ƈقȂꍇA{֐͎s܂B
	{֐͎s NULL Ԃ܂B

	{֐Ŏ擾DBւ̃C^[tFCXnhsvɂȂA
	adbDetach ֐ŊJĂB
*/
ADBM_PREFIX ADBM_HADB ADBM_API adbAttach( ADBM_CSTR pszADBDirPath, ADBM_PCGUID pPathCompFNCID, ADBM_COMPARE pathCompare ) ;

/* ΏۂƂf[^x[X̊֘At */
/*
	݃I[vRlNVɖ{֐ĂяoꍇA
	ҏWe̓[obN܂B
*/
ADBM_PREFIX void ADBM_API adbDetach( ADBM_HADB hADB ) ;

/* pXobt@̏擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetMaxPath( ADBM_HADB hADB ) ;

/* t@Cɐݒł鑮̏擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetMaxFileAttNum( ADBM_HADB hADB ) ;

/* t@C̃Rgobt@̏擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetMaxCommentLength( ADBM_HADB hADB ) ;

/* ̕tTCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetAttExtraDataSize( ADBM_HADB hADB ) ;

/* t@C̕tTCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetFileExtraDataSize( ADBM_HADB hADB ) ;

/* t@CnbṼTCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetHashSize( ADBM_HADB hADB ) ;

/* ̕obt@̏擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API adbGetMaxAttNameLength( ADBM_HADB hADB ) ;

/* f[^x[Xւ̃RlNVJĂ邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbIsOpened( ADBM_HADB hADB ) ;

/* f[^x[Xւ̃RlNVJ */
/*
	waitTime ɂ͑ҋ@Ԃ̏~bŎw肵܂B
	waitTime  0xFFFFFFFF ̏ꍇAf[^x[Xւ̃ANZXlł܂ŉiɑҋ@܂B
	߂lɂ́Af[^x[Xւ̃ANZXlłꍇ ADBM_TRUEA
	^CAEgꍇ ADBM_FALSE Ԃ܂B

	{֐̓VOC^/}`[_K[h@\ƃgUNV@\܂B
	ɂAadbOpen  adbClose ܂ł̏̓vZXԂłK؂ɔr삵܂B
	ǂݍ݃I[vł́Aݗvҋ@邾ŃgUNVO
	ۑ͍sȂ߁A݃I[v荂ɓ삵܂B
	ʏA݃I[vł́AݑI璼 adbClose Ăяo悤ɂA
	RlNV̐L悤ɂĂB
	ݑ adbClose ĂяoɂăR~bg܂B
*/
ADBM_PREFIX ADBM_BOOL ADBM_API adbOpen( ADBM_HADB hADB, ADBM_BOOL bWriteAccess, ADBM_UINT32 waitTime ) ;

/* ݃ANZX邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbIsWriteAccess( ADBM_HADB hADB ) ;

/* gUNVReLXg擾 */
/*
	f[^x[X̃gUNVƓăt@CҏWsKvꍇA
	{֐Ŏ擾gUNVReLXgʂăt@Cs܂B
	gUNVReLXg̃ANZX[h́Af[^x[X̃I[v[hɏ]߁A
	ʏA{֐͏݃I[vɂĂ̂ݗp܂B
	{֐Ŏ擾gUNVReLXǵA
	@f[^x[Xւ̃RlNVƖɂȂ܂B
	@܂A擾gUNVReLXgsvɂȂA
	@adbReleaseTC ֐ŊJĂB
*/
ADBM_PREFIX ADBM_HTC ADBM_API adbGetTC( ADBM_HADB hADB ) ;

/* gUNVReLXgJ */
ADBM_PREFIX void ADBM_API adbReleaseTC( ADBM_HTC hTC ) ;

/* f[^x[Xւ̃RlNV */
/*
	ҏWR~bgɂ́AbCommit  ADBM_TRUE w肵܂B
	ǂݍ݃I[vłꍇAbCommit ̒l͖܂B
*/
ADBM_PREFIX void ADBM_API adbClose( ADBM_HADB hADB, ADBM_BOOL bCommit ) ;

/* ǉ */
ADBM_PREFIX ADBM_REGISTERRESULT ADBM_API adbAttInfoAdd( ADBM_HADB hADB, ADBM_CSTR pszAttName, ADBM_UINT32 * pAttID ) ;

/* ID擾 */
/*
	ƑID(0ȏ)Ԃ܂B
	s0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API adbAttInfoGetID( ADBM_HADB hADB, ADBM_CSTR pszAttName ) ;

/* ݂̑𒲂ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbAttInfoIsExist( ADBM_HADB hADB, ADBM_CSTR pszAttName ) ;

/* IDLł邩ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbAttInfoIsValidID( ADBM_HADB hADB, ADBM_UINT32 attID ) ;

/* ւ̃C^[tFCXJ */
/*
	f[^x[Xɑ΂鏑݃ANZXȂꍇA
	bWriteAccess  ADBM_TRUE w肵ăC^[tFCXJƂ͂ł܂B
*/
ADBM_PREFIX ADBM_HATTINFO ADBM_API adbAttInfoOpen( ADBM_HADB hADB, ADBM_UINT32 attID, ADBM_BOOL bWriteAccess ) ;

/* ւ̃C^[tFCX */
ADBM_PREFIX void ADBM_API adbAttInfoClose( ADBM_HADB hADB, ADBM_HATTINFO hAttInfo ) ;

/* 𑮐f[^x[X폜 */
ADBM_PREFIX void ADBM_API adbAttInfoDelete( ADBM_HADB hADB, ADBM_UINT32 attID ) ;

/* t@Cǉ */
/*
	pXo^ꍇ pszFilePath w肵 pHash  NULL ɂ܂B
	nbVo^ꍇ pHash w肵 pszFilePath  NULL ɂ܂B
	pszFilePath  pHash ̗ NULL łĂ͂Ȃ܂B
*/
ADBM_PREFIX ADBM_REGISTERRESULT ADBM_API adbFileInfoAdd( ADBM_HADB hADB, ADBM_CSTR pszFilePath, const void * pHash, ADBM_UINT32 * pFileID ) ;

/* pXt@CID擾 */
/*
	ƃt@CID(0ȏ)Ԃ܂B
	s0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API adbFileInfoGetIDByPath( ADBM_HADB hADB, ADBM_CSTR pszFilePath ) ;

/* nbVt@CID擾 */
/*
	ƃt@CID(0ȏ)Ԃ܂B
	s0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API adbFileInfoGetIDByHash( ADBM_HADB hADB, const void * pHash ) ;

/* pXt@C݂̑𒲂ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbFileInfoIsExistByPath( ADBM_HADB hADB, ADBM_CSTR pszFilePath ) ;

/* nbVt@C݂̑𒲂ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbFileInfoIsExistByHash( ADBM_HADB hADB, const void * pHash ) ;

/* t@CIDLł邩ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API adbFileInfoIsValidID( ADBM_HADB hADB, ADBM_UINT32 fileID ) ;

/* t@Cւ̃C^[tFCXJ */
/*
	f[^x[Xɑ΂鏑݃ANZXȂꍇA
	bWriteAccess  ADBM_TRUE w肵ăC^[tFCXJƂ͂ł܂B
*/
ADBM_PREFIX ADBM_HFILEINFO ADBM_API adbFileInfoOpen( ADBM_HADB hADB, ADBM_UINT32 fileID, ADBM_BOOL bWriteAccess ) ;

/* t@Cւ̃C^[tFCX */
ADBM_PREFIX void ADBM_API adbFileInfoClose( ADBM_HADB hADB, ADBM_HFILEINFO hFileInfo ) ;

/* t@C𑮐f[^x[X폜 */
/*
	{֐̓fBXÑt@C͍폜Af[^x[X̃t@C񂾂폜܂B
	AnbVo^ĂꍇAnbV͕ێ܂B
	́AadbFileInfoAdd ֐ɂāAnbVo^ꂽꍇƓԂłB
	nbV폜ꍇ bDeleteHash  ADBM_TRUE w肵܂A
	f[^x[X̐݌vvzƂẮAnbV͉ivɕێׂłB
	{֐̓t@C̍폜ɁAdK؂ɍXV܂B
*/
ADBM_PREFIX void ADBM_API adbFileInfoDelete( ADBM_HADB hADB, ADBM_UINT32 fileID, ADBM_BOOL bDeleteHash ) ;

/* 񌟍C^[tFCXJ */
/*
	C^[tFCXJĂ邠A
	@̒ǉ폜A݃I[v͂ł܂B
*/
ADBM_PREFIX ADBM_HFINDATT ADBM_API adbFindAttOpen( ADBM_HADB hADB ) ;

/* 񌟍C^[tFCX */
ADBM_PREFIX void ADBM_API adbFindAttClose( ADBM_HADB hADB, ADBM_HFINDATT hFindAtt ) ;

/* St@ČC^[tFCXJ */
/*
	C^[tFCXJĂ邠A
	@t@C̒ǉ폜A݃I[v͂ł܂B
*/
ADBM_PREFIX ADBM_HFINDFILE ADBM_API adbFindFileAll( ADBM_HADB hADB ) ;

/* 荞݃t@ČC^[tFCXJ */
/*
	C^[tFCXJĂ邠A
	@t@C̒ǉ폜A݃I[v͂ł܂B
*/
ADBM_PREFIX ADBM_HFINDFILE ADBM_API adbFindFileNotImported( ADBM_HADB hADB ) ;

/* 荞ݍς݃t@ČC^[tFCXJ */
/*
	C^[tFCXJĂ邠A
	@t@C̒ǉ폜A݃I[v͂ł܂B
*/
ADBM_PREFIX ADBM_HFINDFILE ADBM_API adbFindFileImported( ADBM_HADB hADB ) ;

/* t@C񌟍C^[tFCXJ */
/*
	w肳ꂽێt@C܂B
	̂ƂAattID ɖȑIDw肳ƁA{֐͎s܂B
	AattID 0w肳ꂽꍇ́Apɋ̃C^[tFCXJ܂B
	C^[tFCXJĂ邠A
	@t@C̒ǉ폜A݃I[v͂ł܂B
*/
ADBM_PREFIX ADBM_HFINDFILE ADBM_API adbFindFileOpen( ADBM_HADB hADB, ADBM_UINT32 attID ) ;

/* s */
/*
	hFindFile ɂ͋̃C^[tFCXw肵܂B
	[hɂĂ͒ǉ񂪕KvɂȂ܂B
	̏ꍇA[hɉāAǉi[\̂ pSearchInfo Ɏw肵܂B
	R[obNĂяoł́A̎_ł̃t@C񐔂 funcInfo ɓn܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API adbFindFileSearch(
	ADBM_HADB hADB, ADBM_HFINDFILE hFindFile, ADBM_SEARCHMODE searchMode, ADBM_PCSEARCHINFO pSearchInfo,
	ADBM_CALLBACK callBack, void * pUserData ) ;

/* t@C񌟍C^[tFCXw肳ꂽ܂ރt@CO */
/*
	{֐Ăяo hFindFile ̌ʒu͐擪ɖ߂܂B
	R[obNĂяoł́A̎_ł̃t@C񐔂 funcInfo ɓn܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API adbFindFileRemove(
	ADBM_HADB hADB, ADBM_HFINDFILE hFindFile, ADBM_UINT32 attIDNum, const ADBM_UINT32 * pAttIDList,
	ADBM_CALLBACK callBack, void * pUserData ) ;

/* t@C񌟍C^[tFCX */
ADBM_PREFIX void ADBM_API adbFindFileClose( ADBM_HADB hADB, ADBM_HFINDFILE hFindFile ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
