/*********************************************************************************
	 API
*********************************************************************************/

#ifndef API_ATTINFO_H
#define API_ATTINFO_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_ATTINFO
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* ݃ANZX邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API aiIsWriteAccess( ADBM_HATTINFO hAttInfo ) ;

/* ID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API aiGetID( ADBM_HATTINFO hAttInfo ) ;

/* ID̐擾 */
/*
	{֐́Ag܂߂ID̐Ԃ܂B
	O[vĂȂꍇ0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API aiGetSyncNum( ADBM_HATTINFO hAttInfo ) ;

/* ID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API aiGetSyncID( ADBM_HATTINFO hAttInfo, ADBM_UINT32 index ) ;

/* IDݒ肷 */
/*
	gAattID wƓƂ݂ȂO[v܂B
	ɂ́Ag铯O[vƁAw肳ꂽ铯O[vƂ𓝍܂B
	O[vꂽ́AtĂt@CLA
	O[v̂ꂩ̑pČƁAO[v̑łێĂ
	t@C񂪃qbg悤ɂȂ܂B
	attID 0w肷Ǝg𓯊O[v番Ɨ܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API aiSetSyncID( ADBM_HATTINFO hAttInfo, ADBM_UINT32 attID ) ;

/* ̎QƃJEg擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API aiGetRefCount( ADBM_HATTINFO hAttInfo ) ;

/* ̂擾 */
/*
	obt@ɏ񂾃oCg(I[0܂)Ԃ܂B
	pBuffer  NULL w肷ƕKvȃobt@TCYԂ܂B
*/
ADBM_PREFIX ADBM_SIZE_T ADBM_API aiGetName( ADBM_HATTINFO hAttInfo, ADBM_STR pBuffer, ADBM_SIZE_T bufferSize ) ;

/* ̂ݒ肷 */
/*
	ɓꖼ݂̂̑ꍇA{֐͎s܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API aiSetName( ADBM_HATTINFO hAttInfo, ADBM_CSTR pszName ) ;

/* 𓝍 */
/*
	͎gA attID włB
	ɐƁȂ̓f[^x[X폜܂B
	̑C^[tFCXJĂꍇA{֐͎s܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API aiCombine( ADBM_HATTINFO hAttInfo, ADBM_UINT32 attID ) ;

/* t擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API aiGetExtraData( ADBM_HATTINFO hAttInfo, void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* tݒ肷 */
ADBM_PREFIX ADBM_ERROR ADBM_API aiSetExtraData( ADBM_HATTINFO hAttInfo, const void * pExtraData ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
