/*********************************************************************************
	t@C API
*********************************************************************************/

#ifndef API_FILEINFO_H
#define API_FILEINFO_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_FILEINFO
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* ݃ANZX邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API fiIsWriteAccess( ADBM_HFILEINFO hFileInfo ) ;

/* t@CID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API fiGetID( ADBM_HFILEINFO hFileInfo ) ;

/* t@CID̐擾 */
/*
	{֐́Ag܂߂t@CID̐Ԃ܂B
	nbV̏dȂꍇ0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API fiGetSyncNum( ADBM_HFILEINFO hFileInfo ) ;

/* t@CID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API fiGetSyncID( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 index ) ;

/* }X^[ID擾 */
/*
	nbV̏dƁAnbVԂőƃRgLꓯ܂B
	̂ƂAf[^x[X̋Lɂē}X^[߂܂B
	{֐ł́A̓}X^[̃t@CID擾鎖ł܂B
	nbV̏dȂꍇ0Ԃ܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API fiGetSyncMaster( ADBM_HFILEINFO hFileInfo ) ;

/* pXo^Ă邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API fiIsPathEnable( ADBM_HFILEINFO hFileInfo ) ;

/* pX擾 */
/*
	obt@ɏ񂾃oCg(I[0܂)Ԃ܂B
	pBuffer  NULL w肷ƕKvȃobt@TCYԂ܂B
*/
ADBM_PREFIX ADBM_SIZE_T ADBM_API fiGetPath( ADBM_HFILEINFO hFileInfo, ADBM_STR pBuffer, ADBM_SIZE_T bufferSize ) ;

/* pXo^ */
ADBM_PREFIX ADBM_REGISTERRESULT ADBM_API fiSetPath( ADBM_HFILEINFO hFileInfo, ADBM_CSTR pszFilePath ) ;

/* nbVo^Ă邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API fiIsHashEnable( ADBM_HFILEINFO hFileInfo ) ;

/* nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API fiGetHash( ADBM_HFILEINFO hFileInfo, void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* nbVo^ */
/*
	̃t@Cɑ΂nbVo^ƓɁAdK؂ɍXV܂B
*/
ADBM_PREFIX ADBM_REGISTERRESULT ADBM_API fiSetHash( ADBM_HFILEINFO hFileInfo, const void * pHash ) ;

/* C|[gĂ邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API fiIsImported( ADBM_HFILEINFO hFileInfo ) ;

/* C|[g */
/*
	nbVo^̏ꍇA{֐͎s܂B
	t@CRs[ڈړăC|[gꍇAbMove  ADBM_TRUE w肵܂B
	f[^x[X́AʏApX̗L(fBXNɎ݂Ă邩)lĂ܂B
	@́Â\[Iȕ(ɓ̃pXȂ)ApXƂēo^ł悤ɂׂ̑[ułB
	@{֐ł́Ãt@Cɓo^ĂpX݂ĂKv܂B
	@܂AɓpXݒ肵Ă̂ȂAOɉ𓀂ALȃpXo^ĂȂ΂Ȃ܂B
*/
ADBM_PREFIX ADBM_REGISTERRESULT ADBM_API fiImport( ADBM_HFILEINFO hFileInfo, ADBM_BOOL bMove ) ;

/* Rg擾 */
/*
	obt@ɏ񂾃oCg(I[0܂)Ԃ܂B
	pBuffer  NULL w肷ƕKvȃobt@TCYԂ܂B
*/
ADBM_PREFIX ADBM_SIZE_T ADBM_API fiGetComment( ADBM_HFILEINFO hFileInfo, ADBM_STR pBuffer, ADBM_SIZE_T bufferSize ) ;

/* Rgݒ肷 */
ADBM_PREFIX ADBM_ERROR ADBM_API fiSetComment( ADBM_HFILEINFO hFileInfo, ADBM_CSTR pszComment ) ;

/* t擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API fiGetExtraData( ADBM_HFILEINFO hFileInfo, void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* tݒ肷 */
ADBM_PREFIX ADBM_ERROR ADBM_API fiSetExtraData( ADBM_HFILEINFO hFileInfo, const void * pExtraData ) ;

/* IDǉ */
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDAdd( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 attID ) ;

/* ID̕т𑮐̂Ń\[g */
/*
	bReverse  ADBM_TRUE w肷 attNameCompare ł̔rʂ̐𔽓]܂B
	~Ń\[gꍇ́AbReverse  ADBM_TRUE w肵܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDSortByName( ADBM_HFILEINFO hFileInfo, ADBM_STRCMP attNameCompare, ADBM_BOOL bReverse ) ;

/* ID̊i[ʒuړ */
/*
	{֐́ApIndices Ŏw肳ꂽʒȗIDSA
	destIndex ̑OփCfbNX̏ő}܂B
	vɁAĨhbOhbvɂבւƓłB
*/
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDMove( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 destIndex, ADBM_UINT32 indexNum, ADBM_UINT32 * pIndices ) ;

/* wʒȗID̊i[ʒuړ */
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDMoveAt( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 destIndex, ADBM_UINT32 index ) ;

/* w肳ꂽIDێĂ邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API fiAttIDFind( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 attID, ADBM_UINT32 * pIndex ) ;

/* ێĂ鑮ID̐擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API fiAttIDGetNum( ADBM_HFILEINFO hFileInfo ) ;

/* wʒȗID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API fiAttIDGetAt( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 index ) ;

/* ID͂ */
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDRemove( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 indexNum, ADBM_UINT32 * pIndices ) ;

/* wʒȗID͂ */
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDRemoveAt( ADBM_HFILEINFO hFileInfo, ADBM_UINT32 index ) ;

/* SĂ̑ID͂ */
ADBM_PREFIX ADBM_ERROR ADBM_API fiAttIDRemoveAll( ADBM_HFILEINFO hFileInfo ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
