/*********************************************************************************
	񌟍 API
*********************************************************************************/

#ifndef API_FINDATT_H
#define API_FINDATT_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_FINDATT
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* ̑擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API faGetNum( ADBM_HFINDATT hFindAtt ) ;

/* ݂̌ʒu擾 */
/*
	ʒu̎擾Ɏs0xFFFFFFFFԂ܂B
	̑0łꍇ{֐͎s܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API faGetIndex( ADBM_HFINDATT hFindAtt ) ;

/* wʒȕ */
/*
	񌟍C^[tFCX̓_ANZXɌĂ܂B
	@ł邾AfaFindNextAfaFindPrev ֐𗘗pĂB
*/
ADBM_PREFIX ADBM_ERROR ADBM_API faFindAt( ADBM_HFINDATT hFindAtt, ADBM_UINT32 index ) ;

/* ̏ */
/*
	{֐͐ ADBM_ERR_SUCCESS Ԃ܂B
	ړɂf[^̏I[𒴂Ă܂ꍇAbMoveAlways  ADBM_TRUE ł΁A
	I[Ɉړ ADBM_ERR_SUCCESS Ԃ܂AbMoveAlways  ADBM_FALSE ł΁A
	J[\̈ړ͍s킸 ADBM_ERR_ABORT Ԃ܂B
	܂AɃf[^̏I[ɒBĂꍇ ADBM_ERR_ABORT Ԃ܂B
	ȊÕG[ ADBM_ERR_GENERAL Ԃ܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API faFindNext( ADBM_HFINDATT hFindAtt, ADBM_UINT32 count, ADBM_BOOL bMoveAlways ) ;

/* Ȍ */
/*
	{֐͐ ADBM_ERR_SUCCESS Ԃ܂B
	ړɂf[^̐擪𒴂Ă܂ꍇAbMoveAlways  ADBM_TRUE ł΁A
	擪Ɉړ ADBM_ERR_SUCCESS Ԃ܂AbMoveAlways  ADBM_FALSE ł΁A
	J[\̈ړ͍s킸 ADBM_ERR_ABORT Ԃ܂B
	܂AɃf[^̐擪ɒBĂꍇ ADBM_ERR_ABORT Ԃ܂B
	ȊÕG[ ADBM_ERR_GENERAL Ԃ܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API faFindPrev( ADBM_HFINDATT hFindAtt, ADBM_UINT32 count, ADBM_BOOL bMoveAlways ) ;

/* ݂̌ʒȗID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API faGetID( ADBM_HFINDATT hFindAtt ) ;

/* ݂̌ʒȗC^[tFCXJ */
/*
	C^[tFCXǂݍ݃[hŊJ܂B
	{֐Ŏ擾C^[tFCX́A
	gI faCloseAttInfo ֐A adbAttInfoClose ֐ŕĂB
*/
ADBM_PREFIX ADBM_HATTINFO ADBM_API faOpenAttInfo( ADBM_HFINDATT hFindAtt ) ;

/* C^[tFCX */
ADBM_PREFIX void ADBM_API faCloseAttInfo( ADBM_HFINDATT hFindAtt, ADBM_HATTINFO hAttInfo ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
