/*********************************************************************************
	t@C񌟍 API
*********************************************************************************/

#ifndef API_FINDFILE_H
#define API_FINDFILE_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_FINDFILE
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* {C^[tFCXɑ΂ adbFindFileSearch ĂяoLł邩ׂ */
/*
	{֐ ADBM_TRUE ԂꍇÃC^[tFCXł邱ƂӖ܂B
	̏ꍇAI܂ŁǍ֐ĂяoĂ͂܂B
*/
ADBM_PREFIX ADBM_BOOL ADBM_API ffIsSerchEnable( ADBM_HFINDFILE hFindFile ) ;

/* {C^[tFCXɑ΂ adbFindFileRemove ĂяoLł邩ׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API ffIsRemoveEnable( ADBM_HFINDFILE hFindFile ) ;

/* ̑擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API ffGetNum( ADBM_HFINDFILE hFindFile ) ;

/* ݂̌ʒu擾 */
/*
	ʒu̎擾Ɏs0xFFFFFFFFԂ܂B
	̑0łꍇ{֐͎s܂B
*/
ADBM_PREFIX ADBM_UINT32 ADBM_API ffGetIndex( ADBM_HFINDFILE hFindFile ) ;

/* wʒȕ */
/*
	񌟍C^[tFCX̓_ANZXɌĂ܂B
	@ł邾AffFindNextAffFindPrev ֐𗘗pĂB
*/
ADBM_PREFIX ADBM_ERROR ADBM_API ffFindAt( ADBM_HFINDFILE hFindFile, ADBM_UINT32 index ) ;

/* ̏ */
/*
	{֐͐ ADBM_ERR_SUCCESS Ԃ܂B
	ړɂf[^̏I[𒴂Ă܂ꍇAbMoveAlways  ADBM_TRUE ł΁A
	I[Ɉړ ADBM_ERR_SUCCESS Ԃ܂AbMoveAlways  ADBM_FALSE ł΁A
	J[\̈ړ͍s킸 ADBM_ERR_ABORT Ԃ܂B
	܂AɃf[^̏I[ɒBĂꍇ ADBM_ERR_ABORT Ԃ܂B
	ȊÕG[ ADBM_ERR_GENERAL Ԃ܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API ffFindNext( ADBM_HFINDFILE hFindFile, ADBM_UINT32 count, ADBM_BOOL bMoveAlways ) ;

/* Ȍ */
/*
	{֐͐ ADBM_ERR_SUCCESS Ԃ܂B
	ړɂf[^̐擪𒴂Ă܂ꍇAbMoveAlways  ADBM_TRUE ł΁A
	擪Ɉړ ADBM_ERR_SUCCESS Ԃ܂AbMoveAlways  ADBM_FALSE ł΁A
	J[\̈ړ͍s킸 ADBM_ERR_ABORT Ԃ܂B
	܂AɃf[^̐擪ɒBĂꍇ ADBM_ERR_ABORT Ԃ܂B
	ȊÕG[ ADBM_ERR_GENERAL Ԃ܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API ffFindPrev( ADBM_HFINDFILE hFindFile, ADBM_UINT32 count, ADBM_BOOL bMoveAlways ) ;

/* ݂̌ʒũt@CID擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API ffGetID( ADBM_HFINDFILE hFindFile ) ;

/* ݂̌ʒũt@CC^[tFCXJ */
/*
	t@CC^[tFCXǂݍ݃[hŊJ܂B
	{֐Ŏ擾t@CC^[tFCX́A
	gI ffCloseFileInfo ֐A adbFileInfoClose ֐ŕĂB
*/
ADBM_PREFIX ADBM_HFILEINFO ADBM_API ffOpenFileInfo( ADBM_HFINDFILE hFindFile ) ;

/* t@CC^[tFCX */
ADBM_PREFIX void ADBM_API ffCloseFileInfo( ADBM_HFINDFILE hFindFile, ADBM_HFILEINFO hFileInfo ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
