/*********************************************************************************
	gUNVReLXg API
*********************************************************************************/

#ifndef API_TRNSCNTXT_H
#define API_TRNSCNTXT_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_TRNSCNTXT
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* ݃ANZX邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API tcIsWriteAccess( ADBM_HTC hTC ) ;

/* t@CJ */
/*
	ǂݏANZXł́AɊJĂt@C͊J܂B
	t@CI[vɎsƁA{֐ NULL Ԃ܂B
	{֐Ŏ擾t@Cnh́Af[^x[Xւ̃RlNVOɁA
	K tcCloseFile ֐ŕȂ΂Ȃ܂B
*/
ADBM_PREFIX ADBM_HTFILE ADBM_API tcOpenFile( ADBM_HTC hTC, ADBM_CSTR pszFilePath, ADBM_BOOL bWriteAccess ) ;

/* t@Cǂݍ */
ADBM_PREFIX ADBM_UINT32 ADBM_API tcFileRead( ADBM_HTFILE hTFile, void * pBuffer, ADBM_UINT32 size ) ;

/* t@C֏ */
ADBM_PREFIX ADBM_UINT32 ADBM_API tcFileWrite( ADBM_HTFILE hTFile, const void * pBuffer, ADBM_UINT32 size ) ;

/* t@CTCY擾 */
ADBM_PREFIX ADBM_UINT64 ADBM_API tcFileGetSize( ADBM_HTFILE hTFile ) ;

/* t@Cʒuړ */
/*
	seekOrigin ɂ͈ړ̊intl fseek ݊Ŏw肵܂B
	SEEK_SET@it@C̐擪j
	SEEK_CUR@it@Č݈ʒuj
	SEEK_END@it@C̏I[j
*/
ADBM_PREFIX ADBM_UINT64 ADBM_API tcFileSeek( ADBM_HTFILE hTFile, ADBM_INT64 offset, int seekOrigin ) ;

/* t@Cʒu擾 */
ADBM_PREFIX ADBM_UINT64 ADBM_API tcFileGetPosition( ADBM_HTFILE hTFile ) ;

/* ݂̃t@Cʒut@CI[ɂ */
ADBM_PREFIX void ADBM_API tcFileSetEndOfFile( ADBM_HTFILE hTFile ) ;

/* t@C */
ADBM_PREFIX void ADBM_API tcCloseFile( ADBM_HTC hTC, ADBM_HTFILE hTFile ) ;

/* t@C쐬 */
ADBM_PREFIX ADBM_ERROR ADBM_API tcCreateFile( ADBM_HTC hTC, ADBM_CSTR pszFilePath ) ;

/* t@C폜 */
ADBM_PREFIX void ADBM_API tcDeleteFile( ADBM_HTC hTC, ADBM_CSTR pszFilePath ) ;

/* fBNg쐬 */
ADBM_PREFIX ADBM_ERROR ADBM_API tcCreateDirectory( ADBM_HTC hTC, ADBM_CSTR pszDirPath ) ;

/* fBNg폜 */
ADBM_PREFIX void ADBM_API tcDeleteDirectory( ADBM_HTC hTC, ADBM_CSTR pszDirPath ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
